您的位置:首页 > 其它

Codeforces Round #345 (Div. 2)(A)(记忆化搜索)

2016-03-07 21:42 323 查看
A. Joysticks

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

Friends are going to play console. They have two joysticks and only one charger for them. Initially first joystick is charged at a1 percent
and second one is charged at a2 percent.
You can connect charger to a joystick only at the beginning of each minute. In one minute joystick either discharges by 2 percent (if not connected to a charger) or charges by 1 percent (if connected to a charger).

Game continues while both joysticks have a positive charge. Hence, if at the beginning of minute some joystick is charged by 1 percent, it has to be connected to a charger, otherwise the game stops. If some joystick completely discharges (its charge turns to
0), the game also stops.

Determine the maximum number of minutes that game can last. It is prohibited to pause the game, i. e. at each moment both joysticks should be enabled. It is allowed for joystick to be charged by more
than 100 percent.

Input

The first line of the input contains two positive integers a1 and a2 (1 ≤ a1, a2 ≤ 100),
the initial charge level of first and second joystick respectively.

Output

Output the only integer, the maximum number of minutes that the game can last. Game continues until some joystick is discharged.

Examples

input
3 5


output
6


input
4 4


output
5


Note

In the first sample game lasts for 6 minute by using the following algorithm:

at the beginning of the first minute connect first joystick to the charger, by the end of this minute first joystick is at 4%, second is at 3%;

continue the game without changing charger, by the end of the second minute the first joystick is at 5%, second is at 1%;

at the beginning of the third minute connect second joystick to the charger, after this minute the first joystick is at 3%, the second one is at 2%;

continue the game without changing charger, by the end of the fourth minute first joystick is at 1%, second one is at 3%;

at the beginning of the fifth minute connect first joystick to the charger, after this minute the first joystick is at 2%, the second one is at 1%;

at the beginning of the sixth minute connect second joystick to the charger, after this minute the first joystick is at 0%, the second one is at 2%.

After that the first joystick is completely discharged and the game is stopped.

题意:你有2个数字,A,B每次你可以让(A+1,B-2)或者(A-2,B+1),(A==0||B==0)结束,问最多可以坚持多少回合,

题解:开始直接暴力TLE,想了一下难道转态很多?于是就写了一个记忆化搜索减少无用的状态搜索,WA7的同学,这里注意数据(1,1)特判一下吧。

#include <set>
#include <map>
#include <list>
#include <cmath>
#include <queue>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <iomanip>
#include <iostream>
#include <sstream>
#include <algorithm>
#define LL long long
using namespace std;
#define N int(2e2)
#define inf 0x3f3f3f3f
int ans;
int dp

;
int dfs(int x, int y)
{
if (x == 0 || y == 0)
return 1;
if (dp[x][y] != -1)
return dp[x][y];
if (x >0&&y>0)
{
if (x - 2 >= 0)
dp[x][y]=max(dfs(x - 2, y + 1)+1,dp[x][y]);
if (y - 2 >= 0)
dp[x][y]=max(dp[x][y],dfs(x + 1, y - 2)+1);
}
return dp[x][y];
}
int main()
{
#ifdef CDZSC
freopen("i.txt", "r", stdin);
#endif
int a, b;
while (~scanf("%d%d", &a, &b))
{
memset(dp, -1, sizeof(dp));
ans = 0;
dfs(a, b);
if (a <= 1 && b <= 1)
dp[a][b] = 1;
printf("%d\n",dp[a][b]-1);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: